## r-cran-s2 1.0.4

=== DESCRIPTION ===
Package: s2
Title: Spherical Geometry Operators Using the S2 Geometry Library
Version: 1.0.4
Authors@R: c(
     person(given = "Dewey",
           family = "Dunnington",
           role = c("aut"),
           email = "dewey@fishandwhistle.net",
           comment = c(ORCID = "0000-0002-9415-4582")),
     person(given = "Edzer",
             family = "Pebesma",
             role = c("aut", "cre"),
             email = "edzer.pebesma@uni-muenster.de",
             comment = c(ORCID = "0000-0001-8049-7069")),
    person("Ege", "Rubak", email="rubak@math.aau.dk", role = c("aut")),
    person("Jeroen", "Ooms", , "jeroen.ooms@stat.ucla.edu", role = "ctb", comment = "configure script"),
    person(family = "Google, Inc.", role = "cph", comment = "Original s2geometry.io source code")
  )
Description: Provides R bindings for Google's s2 library for geometric calculations on
    the sphere. High-performance constructors and exporters provide high compatibility
    with existing spatial packages, transformers construct new geometries from existing
    geometries, predicates provide a means to select geometries based on spatial 
    relationships, and accessors extract information about geometries.
License: Apache License (== 2.0)
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.1
LinkingTo: Rcpp, wk
Imports: Rcpp, wk
Suggests: testthat, vctrs
URL: https://r-spatial.github.io/s2/, https://github.com/r-spatial/s2,
        https://s2geometry.io/
BugReports: https://github.com/r-spatial/s2/issues
Depends: R (>= 3.0.0)
NeedsCompilation: yes
Packaged: 2021-01-04 15:35:03 UTC; edzer
Author: Dewey Dunnington [aut] (<https://orcid.org/0000-0002-9415-4582>),
  Edzer Pebesma [aut, cre] (<https://orcid.org/0000-0001-8049-7069>),
  Ege Rubak [aut],
  Jeroen Ooms [ctb] (configure script),
  Google, Inc. [cph] (Original s2geometry.io source code)
Maintainer: Edzer Pebesma <edzer.pebesma@uni-muenster.de>
Repository: CRAN
Date/Publication: 2021-01-05 05:10:02 UTC

=== debian/changelog ===
r-cran-s2 (1.0.4-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Sat, 16 Jan 2021 17:30:37 +0100

r-cran-s2 (1.0.3-2) unstable; urgency=medium

  * change uint64 to uint64_t in unaligned_access
    Closes: #976473
  * Standards-Version: 4.5.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 10 Dec 2020 08:26:41 +0100

r-cran-s2 (1.0.3-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 13 (routine-update)
  * Trim trailing whitespace.
  * Set upstream metadata fields: Archive, Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Sun, 18 Oct 2020 23:03:45 +0200

r-cran-s2 (1.0.2-1) unstable; urgency=medium

  * Initial release (closes: #970713)

 -- Andreas Tille <tille@debian.org>  Tue, 22 Sep 2020 11:28:09 +0200

=== debian/control ===
Source: r-cran-s2
Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
Uploaders: Andreas Tille <tille@debian.org>
Section: gnu-r
Testsuite: autopkgtest-pkg-r
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-r,
               r-base-dev,
               r-cran-rcpp,
               r-cran-wk,
               libssl-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-s2
Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-s2.git
Homepage: https://cran.r-project.org/package=s2
Rules-Requires-Root: no

Package: r-cran-s2
Architecture: any
Depends: ${R:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: ${R:Recommends}
Suggests: ${R:Suggests}
Description: GNU R spherical geometry operators using the S2 geometry library
 Provides R bindings for Google's s2 library for geometric calculations
 on the sphere. High-performance constructors and exporters provide high
 compatibility with existing spatial packages, transformers construct new
 geometries from existing geometries, predicates provide a means to
 select geometries based on spatial relationships, and accessors extract
 information about geometries.

## r-cran-s2 1.0.7

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: s2
 Title: Spherical Geometry Operators Using the S2 Geometry Library
-Version: 1.0.4
+Version: 1.0.7
 Authors@R: c(
      person(given = "Dewey",
            family = "Dunnington",
@@ -24,16 +24,17 @@
 License: Apache License (== 2.0)
 Encoding: UTF-8
 LazyData: true
-RoxygenNote: 7.1.1
+RoxygenNote: 7.1.2
+SystemRequirements: OpenSSL >= 1.0.1
 LinkingTo: Rcpp, wk
-Imports: Rcpp, wk
+Imports: Rcpp, wk (>= 0.5.0)
 Suggests: testthat, vctrs
 URL: https://r-spatial.github.io/s2/, https://github.com/r-spatial/s2,
         https://s2geometry.io/
 BugReports: https://github.com/r-spatial/s2/issues
 Depends: R (>= 3.0.0)
 NeedsCompilation: yes
-Packaged: 2021-01-04 15:35:03 UTC; edzer
+Packaged: 2021-09-22 15:42:08 UTC; edzer
 Author: Dewey Dunnington [aut] (<https://orcid.org/0000-0002-9415-4582>),
   Edzer Pebesma [aut, cre] (<https://orcid.org/0000-0001-8049-7069>),
   Ege Rubak [aut],
@@ -41,4 +42,4 @@
   Google, Inc. [cph] (Original s2geometry.io source code)
 Maintainer: Edzer Pebesma <edzer.pebesma@uni-muenster.de>
 Repository: CRAN
-Date/Publication: 2021-01-05 05:10:02 UTC
+Date/Publication: 2021-09-28 09:40:02 UTC

=== debian/changelog ===
r-cran-s2 (1.0.7-3build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Wed, 24 Nov 2021 11:12:02 +0100

r-cran-s2 (1.0.7-3) unstable; urgency=medium

  * d/p/fix-armel-ftbfs.patch
    + Extend patch to fix FTBFS on mipsel, m68k, powerpc and riscv64
  * Add myself to uploaders
  * [skip ci] d/salsa-ci.yml: Disable reprotest

 -- Nilesh Patra <nilesh@debian.org>  Wed, 06 Oct 2021 16:08:58 +0530

r-cran-s2 (1.0.7-2) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix FTBFS on armel

 -- Nilesh Patra <nilesh@debian.org>  Tue, 05 Oct 2021 16:34:37 +0530

r-cran-s2 (1.0.7-1) unstable; urgency=medium

  [ Nilesh Patra ]
  * Team upload.
  * New upstream version 1.0.7
  * d/control: Update versioned B-D
  * d/copyright: Fix copyright files for absl to right location

  [ Étienne Mollier ]
  * add fix-ftbfs-on-32bit.patch from Konstantin Podsirov

 -- Étienne Mollier <emollier@debian.org>  Mon, 04 Oct 2021 21:37:06 +0200

r-cran-s2 (1.0.6-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 26 Aug 2021 12:48:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: r-cran-s2
 Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>, Nilesh Patra <nilesh@debian.org>
 Section: gnu-r
 Testsuite: autopkgtest-pkg-r
 Priority: optional
@@ -8,9 +8,9 @@
                dh-r,
                r-base-dev,
                r-cran-rcpp,
-               r-cran-wk,
+               r-cran-wk (>= 0.5.0),
                libssl-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-s2
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-s2.git
 Homepage: https://cran.r-project.org/package=s2

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, r-cran-testthat, r-cran-vctrs
Restrictions: allow-stderr

## r-cran-s2 1.1.0

=== debian/changelog ===
r-cran-s2 (1.1.0-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 21 Jul 2022 17:46:21 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,20 @@
 Source: r-cran-s2
+Section: gnu-r
+Priority: optional
 Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
 Uploaders: Andreas Tille <tille@debian.org>, Nilesh Patra <nilesh@debian.org>
-Section: gnu-r
-Testsuite: autopkgtest-pkg-r
-Priority: optional
+Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-s2
+Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-s2.git
+Homepage: https://cran.r-project.org/package=s2
+Standards-Version: 4.6.1
+Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                dh-r,
                r-base-dev,
                r-cran-rcpp,
-               r-cran-wk (>= 0.5.0),
+               r-cran-wk (>= 0.6.0),
                libssl-dev
-Standards-Version: 4.6.0
-Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-s2
-Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-s2.git
-Homepage: https://cran.r-project.org/package=s2
-Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-r
 
 Package: r-cran-s2
 Architecture: any

## r-cran-s2 1.1.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: s2
 Title: Spherical Geometry Operators Using the S2 Geometry Library
-Version: 1.0.7
+Version: 1.1.2
 Authors@R: c(
      person(given = "Dewey",
            family = "Dunnington",
@@ -24,17 +24,18 @@
 License: Apache License (== 2.0)
 Encoding: UTF-8
 LazyData: true
-RoxygenNote: 7.1.2
+RoxygenNote: 7.2.3
 SystemRequirements: OpenSSL >= 1.0.1
 LinkingTo: Rcpp, wk
-Imports: Rcpp, wk (>= 0.5.0)
-Suggests: testthat, vctrs
+Imports: Rcpp, wk (>= 0.6.0)
+Suggests: testthat (>= 3.0.0), vctrs
 URL: https://r-spatial.github.io/s2/, https://github.com/r-spatial/s2,
         https://s2geometry.io/
 BugReports: https://github.com/r-spatial/s2/issues
 Depends: R (>= 3.0.0)
+Config/testthat/edition: 3
 NeedsCompilation: yes
-Packaged: 2021-09-22 15:42:08 UTC; edzer
+Packaged: 2023-01-11 14:23:27 UTC; edzer
 Author: Dewey Dunnington [aut] (<https://orcid.org/0000-0002-9415-4582>),
   Edzer Pebesma [aut, cre] (<https://orcid.org/0000-0001-8049-7069>),
   Ege Rubak [aut],
@@ -42,4 +43,4 @@
   Google, Inc. [cph] (Original s2geometry.io source code)
 Maintainer: Edzer Pebesma <edzer.pebesma@uni-muenster.de>
 Repository: CRAN
-Date/Publication: 2021-09-28 09:40:02 UTC
+Date/Publication: 2023-01-12 13:00:02 UTC

=== debian/changelog ===
r-cran-s2 (1.1.2-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 16 Jan 2023 13:49:37 +0100

r-cran-s2 (1.1.1-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 28 Nov 2022 15:28:30 +0100

## r-cran-s2 1.1.4

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: s2
 Title: Spherical Geometry Operators Using the S2 Geometry Library
-Version: 1.1.2
+Version: 1.1.4
 Authors@R: c(
      person(given = "Dewey",
            family = "Dunnington",
@@ -28,14 +28,14 @@
 SystemRequirements: OpenSSL >= 1.0.1
 LinkingTo: Rcpp, wk
 Imports: Rcpp, wk (>= 0.6.0)
-Suggests: testthat (>= 3.0.0), vctrs
+Suggests: bit64, testthat (>= 3.0.0), vctrs
 URL: https://r-spatial.github.io/s2/, https://github.com/r-spatial/s2,
         https://s2geometry.io/
 BugReports: https://github.com/r-spatial/s2/issues
 Depends: R (>= 3.0.0)
 Config/testthat/edition: 3
 NeedsCompilation: yes
-Packaged: 2023-01-11 14:23:27 UTC; edzer
+Packaged: 2023-05-16 15:01:01 UTC; edzer
 Author: Dewey Dunnington [aut] (<https://orcid.org/0000-0002-9415-4582>),
   Edzer Pebesma [aut, cre] (<https://orcid.org/0000-0001-8049-7069>),
   Ege Rubak [aut],
@@ -43,4 +43,4 @@
   Google, Inc. [cph] (Original s2geometry.io source code)
 Maintainer: Edzer Pebesma <edzer.pebesma@uni-muenster.de>
 Repository: CRAN
-Date/Publication: 2023-01-12 13:00:02 UTC
+Date/Publication: 2023-05-17 10:40:02 UTC

=== debian/changelog ===
r-cran-s2 (1.1.4-1) unstable; urgency=medium

  * New upstream version
  * Test-Depends as per Suggests

 -- Andreas Tille <tille@debian.org>  Fri, 30 Jun 2023 21:49:50 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-s2
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-s2.git
 Homepage: https://cran.r-project.org/package=s2
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                dh-r,

=== debian/tests/control ===
Tests: run-unit-test
Depends: @,
         r-cran-bit64,
         r-cran-testthat,
         r-cran-vctrs
Restrictions: allow-stderr

## r-cran-s2 1.1.6

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: s2
 Title: Spherical Geometry Operators Using the S2 Geometry Library
-Version: 1.1.4
+Version: 1.1.6
 Authors@R: c(
      person(given = "Dewey",
            family = "Dunnington",
@@ -30,12 +30,12 @@
 Imports: Rcpp, wk (>= 0.6.0)
 Suggests: bit64, testthat (>= 3.0.0), vctrs
 URL: https://r-spatial.github.io/s2/, https://github.com/r-spatial/s2,
-        https://s2geometry.io/
+        http://s2geometry.io/
 BugReports: https://github.com/r-spatial/s2/issues
 Depends: R (>= 3.0.0)
 Config/testthat/edition: 3
 NeedsCompilation: yes
-Packaged: 2023-05-16 15:01:01 UTC; edzer
+Packaged: 2023-12-19 14:38:19 UTC; edzer
 Author: Dewey Dunnington [aut] (<https://orcid.org/0000-0002-9415-4582>),
   Edzer Pebesma [aut, cre] (<https://orcid.org/0000-0001-8049-7069>),
   Ege Rubak [aut],
@@ -43,4 +43,4 @@
   Google, Inc. [cph] (Original s2geometry.io source code)
 Maintainer: Edzer Pebesma <edzer.pebesma@uni-muenster.de>
 Repository: CRAN
-Date/Publication: 2023-05-17 10:40:02 UTC
+Date/Publication: 2023-12-19 17:20:05 UTC

=== debian/changelog ===
r-cran-s2 (1.1.6-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:33:21 +1100

r-cran-s2 (1.1.6-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:10:36 +0000

r-cran-s2 (1.1.6-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Tue, 09 Jan 2024 09:20:15 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: r-cran-s2
 Section: gnu-r
 Priority: optional
-Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
 Uploaders: Andreas Tille <tille@debian.org>, Nilesh Patra <nilesh@debian.org>
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-s2
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-s2.git

=== debian/tests/control ===
Tests: run-unit-test
Depends: @,
         r-cran-bit64,
        r-cran-testthat (>= 3.0.0),
        r-cran-vctrs
Restrictions: allow-stderr

## r-cran-s2 1.1.7

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: s2
 Title: Spherical Geometry Operators Using the S2 Geometry Library
-Version: 1.1.6
+Version: 1.1.7
 Authors@R: c(
      person(given = "Dewey",
            family = "Dunnington",
@@ -35,7 +35,7 @@
 Depends: R (>= 3.0.0)
 Config/testthat/edition: 3
 NeedsCompilation: yes
-Packaged: 2023-12-19 14:38:19 UTC; edzer
+Packaged: 2024-07-17 06:46:09 UTC; edzer
 Author: Dewey Dunnington [aut] (<https://orcid.org/0000-0002-9415-4582>),
   Edzer Pebesma [aut, cre] (<https://orcid.org/0000-0001-8049-7069>),
   Ege Rubak [aut],
@@ -43,4 +43,4 @@
   Google, Inc. [cph] (Original s2geometry.io source code)
 Maintainer: Edzer Pebesma <edzer.pebesma@uni-muenster.de>
 Repository: CRAN
-Date/Publication: 2023-12-19 17:20:05 UTC
+Date/Publication: 2024-07-17 13:50:02 UTC

=== debian/changelog ===
r-cran-s2 (1.1.7-2) unstable; urgency=medium

  * Team upload.
  * Warn that this may be buggy on 32-bit systems
    and skip autopkgtest on i386. (Closes: #1104160)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Mon, 28 Apr 2025 19:16:30 +0100

r-cran-s2 (1.1.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * Unfuzz debian/patches/fix-armel-ftbfs.patch

 -- Charles Plessy <plessy@debian.org>  Fri, 04 Oct 2024 08:37:27 +0900

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: r-cran-s2
 Section: gnu-r
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
+Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
 Uploaders: Andreas Tille <tille@debian.org>, Nilesh Patra <nilesh@debian.org>
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-s2
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-s2.git
 Homepage: https://cran.r-project.org/package=s2
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                dh-r,

## r-cran-s2 1.1.9

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: s2
 Title: Spherical Geometry Operators Using the S2 Geometry Library
-Version: 1.1.7
+Version: 1.1.9
 Authors@R: c(
      person(given = "Dewey",
            family = "Dunnington",
@@ -19,13 +19,13 @@
 Description: Provides R bindings for Google's s2 library for geometric calculations on
     the sphere. High-performance constructors and exporters provide high compatibility
     with existing spatial packages, transformers construct new geometries from existing
-    geometries, predicates provide a means to select geometries based on spatial 
+    geometries, predicates provide a means to select geometries based on spatial
     relationships, and accessors extract information about geometries.
 License: Apache License (== 2.0)
 Encoding: UTF-8
 LazyData: true
-RoxygenNote: 7.2.3
-SystemRequirements: OpenSSL >= 1.0.1
+RoxygenNote: 7.3.2
+SystemRequirements: cmake, OpenSSL >= 1.0.1, Abseil >= 20230802.0
 LinkingTo: Rcpp, wk
 Imports: Rcpp, wk (>= 0.6.0)
 Suggests: bit64, testthat (>= 3.0.0), vctrs
@@ -35,12 +35,13 @@
 Depends: R (>= 3.0.0)
 Config/testthat/edition: 3
 NeedsCompilation: yes
-Packaged: 2024-07-17 06:46:09 UTC; edzer
-Author: Dewey Dunnington [aut] (<https://orcid.org/0000-0002-9415-4582>),
-  Edzer Pebesma [aut, cre] (<https://orcid.org/0000-0001-8049-7069>),
+Packaged: 2025-05-23 14:44:45 UTC; edzer
+Author: Dewey Dunnington [aut] (ORCID: <https://orcid.org/0000-0002-9415-4582>),
+  Edzer Pebesma [aut, cre] (ORCID:
+    <https://orcid.org/0000-0001-8049-7069>),
   Ege Rubak [aut],
   Jeroen Ooms [ctb] (configure script),
   Google, Inc. [cph] (Original s2geometry.io source code)
 Maintainer: Edzer Pebesma <edzer.pebesma@uni-muenster.de>
 Repository: CRAN
-Date/Publication: 2024-07-17 13:50:02 UTC
+Date/Publication: 2025-05-23 15:50:02 UTC

=== tools/vendor/abseil-cpp/CMakeLists.txt ===
#
# Copyright 2017 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# https://github.com/google/oss-policies-info/blob/main/foundational-cxx-support-matrix.md
# As of 2022-09-06, CMake 3.10 is the minimum supported version.
cmake_minimum_required(VERSION 3.10)

# Compiler id for Apple Clang is now AppleClang.
if (POLICY CMP0025)
  cmake_policy(SET CMP0025 NEW)
endif (POLICY CMP0025)

# if command can use IN_LIST
if (POLICY CMP0057)
  cmake_policy(SET CMP0057 NEW)
endif (POLICY CMP0057)

# Project version variables are the empty string if version is unspecified
if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif (POLICY CMP0048)

# option() honor variables
if (POLICY CMP0077)
  cmake_policy(SET CMP0077 NEW)
endif (POLICY CMP0077)

# Allow the user to specify the MSVC runtime
if (POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif (POLICY CMP0091)

# try_compile() honors the CMAKE_CXX_STANDARD value
if (POLICY CMP0067)
  cmake_policy(SET CMP0067 NEW)
endif (POLICY CMP0067)

# Allow the user to specify the CMAKE_MSVC_DEBUG_INFORMATION_FORMAT
if (POLICY CMP0141)
  cmake_policy(SET CMP0141 NEW)
endif (POLICY CMP0141)

project(absl LANGUAGES CXX VERSION 20230802)
include(CTest)

# Output directory is correct by default for most build setups. However, when
# building Abseil as a DLL, it is important to have the DLL in the same
# directory as the executable using it. Thus, we put all executables in a single
# /bin directory.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# when absl is included as subproject (i.e. using add_subdirectory(abseil-cpp))
# in the source tree of a project that uses it, install rules are disabled.
if(NOT CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  option(ABSL_ENABLE_INSTALL "Enable install rule" OFF)
else()
  option(ABSL_ENABLE_INSTALL "Enable install rule" ON)
endif()

option(ABSL_PROPAGATE_CXX_STD
  "Use CMake C++ standard meta features (e.g. cxx_std_14) that propagate to targets that link to Abseil"
  OFF)  # TODO: Default to ON for CMake 3.8 and greater.
if(NOT ABSL_PROPAGATE_CXX_STD)
  message(WARNING "A future Abseil release will default ABSL_PROPAGATE_CXX_STD to ON for CMake 3.8 and up. We recommend enabling this option to ensure your project still builds correctly.")
endif()

option(ABSL_USE_SYSTEM_INCLUDES
  "Silence warnings in Abseil headers by marking them as SYSTEM includes"
  OFF)

list(APPEND CMAKE_MODULE_PATH
  ${CMAKE_CURRENT_LIST_DIR}/CMake
  ${CMAKE_CURRENT_LIST_DIR}/absl/copts
)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)
include(AbseilDll)
include(AbseilHelpers)


##
## Using absl targets
##
## all public absl targets are
## exported with the absl:: prefix
##
## e.g absl::base absl::synchronization absl::strings ....
##
## DO NOT rely on the internal targets outside of the prefix


# include current path
list(APPEND ABSL_COMMON_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR})

if("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
  set(ABSL_USING_CLANG ON)
else()
  set(ABSL_USING_CLANG OFF)
endif()

# find dependencies
## pthread
find_package(Threads REQUIRED)

include(CMakeDependentOption)

option(ABSL_BUILD_TESTING
  "If ON, Abseil will build all of Abseil's own tests." OFF)

option(ABSL_BUILD_TEST_HELPERS
  "If ON, Abseil will build libraries that you can use to write tests against Abseil code. This option requires that Abseil is configured to use GoogleTest."
  OFF)

option(ABSL_USE_EXTERNAL_GOOGLETEST
  "If ON, Abseil will assume that the targets for GoogleTest are already provided by the including project. This makes sense when Abseil is used with add_subdirectory." OFF)

cmake_dependent_option(ABSL_FIND_GOOGLETEST
  "If ON, Abseil will use find_package(GTest) rather than assuming that GoogleTest is already provided by the including project."
  ON
  "ABSL_USE_EXTERNAL_GOOGLETEST"
  OFF)


option(ABSL_USE_GOOGLETEST_HEAD
  "If ON, abseil will download HEAD from GoogleTest at config time." OFF)

set(ABSL_GOOGLETEST_DOWNLOAD_URL "" CACHE STRING "If set, download GoogleTest from this URL")

set(ABSL_LOCAL_GOOGLETEST_DIR "/usr/src/googletest" CACHE PATH
  "If ABSL_USE_GOOGLETEST_HEAD is OFF and ABSL_GOOGLETEST_URL is not set, specifies the directory of a local GoogleTest checkout."
  )

if((BUILD_TESTING AND ABSL_BUILD_TESTING) OR ABSL_BUILD_TEST_HELPERS)
  if (ABSL_USE_EXTERNAL_GOOGLETEST)
    if (ABSL_FIND_GOOGLETEST)
      find_package(GTest REQUIRED)
    elseif(NOT TARGET GTest::gtest)
      if(TARGET gtest)
        # When Google Test is included directly rather than through find_package, the aliases are missing.
        add_library(GTest::gtest ALIAS gtest)
        add_library(GTest::gtest_main ALIAS gtest_main)
        add_library(GTest::gmock ALIAS gmock)
        add_library(GTest::gmock_main ALIAS gmock_main)
      else()
        message(FATAL_ERROR "ABSL_USE_EXTERNAL_GOOGLETEST is ON and ABSL_FIND_GOOGLETEST is OFF, which means that the top-level project must build the Google Test project. However, the target gtest was not found.")
      endif()
    endif()
  else()
    set(absl_gtest_build_dir ${CMAKE_BINARY_DIR}/googletest-build)
    if(ABSL_USE_GOOGLETEST_HEAD AND ABSL_GOOGLETEST_DOWNLOAD_URL)
      message(FATAL_ERROR "Do not set both ABSL_USE_GOOGLETEST_HEAD and ABSL_GOOGLETEST_DOWNLOAD_URL")
    endif()
    if(ABSL_USE_GOOGLETEST_HEAD)
      set(absl_gtest_download_url "https://github.com/google/googletest/archive/main.zip")
    elseif(ABSL_GOOGLETEST_DOWNLOAD_URL)
      set(absl_gtest_download_url ${ABSL_GOOGLETEST_DOWNLOAD_URL})
    endif()
    if(absl_gtest_download_url)
      set(absl_gtest_src_dir ${CMAKE_BINARY_DIR}/googletest-src)
    else()
      set(absl_gtest_src_dir ${ABSL_LOCAL_GOOGLETEST_DIR})
    endif()
    include(CMake/Googletest/DownloadGTest.cmake)
  endif()
endif()

add_subdirectory(absl)

if(ABSL_ENABLE_INSTALL)
  

  # install as a subdirectory only
  install(EXPORT ${PROJECT_NAME}Targets
    NAMESPACE absl::
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )

  configure_package_config_file(
    CMake/abslConfig.cmake.in
    "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )
  install(FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )

  # Abseil only has a version in LTS releases.  This mechanism is accomplished
  # Abseil's internal Copybara (https://github.com/google/copybara) workflows and
  # isn't visible in the CMake buildsystem itself.
  if(absl_VERSION)
    write_basic_package_version_file(
      "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
      COMPATIBILITY ExactVersion
    )

    install(FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
      DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
    )
  endif()  # absl_VERSION

  install(DIRECTORY absl
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    FILES_MATCHING
      PATTERN "*.inc"
      PATTERN "*.h"
      PATTERN "copts" EXCLUDE
      PATTERN "testdata" EXCLUDE
    )

  file(READ "absl/base/options.h" ABSL_INTERNAL_OPTIONS_H_CONTENTS)
  if (ABSL_INTERNAL_AT_LEAST_CXX17)
    string(REGEX REPLACE
      "#define ABSL_OPTION_USE_STD_([^ ]*) 2"
      "#define ABSL_OPTION_USE_STD_\\1 1"
      ABSL_INTERNAL_OPTIONS_H_PINNED
      "${ABSL_INTERNAL_OPTIONS_H_CONTENTS}")
  else()
    string(REGEX REPLACE
      "#define ABSL_OPTION_USE_STD_([^ ]*) 2"
      "#define ABSL_OPTION_USE_STD_\\1 0"
      ABSL_INTERNAL_OPTIONS_H_PINNED
      "${ABSL_INTERNAL_OPTIONS_H_CONTENTS}")
  endif()
  file(WRITE "${CMAKE_BINARY_DIR}/options-pinned.h" "${ABSL_INTERNAL_OPTIONS_H_PINNED}")

  install(FILES "${CMAKE_BINARY_DIR}/options-pinned.h"
         DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/absl/base
         RENAME "options.h")

endif()  # ABSL_ENABLE_INSTALL

=== tools/vendor/abseil-cpp/absl/algorithm/CMakeLists.txt ===
#
# Copyright 2017 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

absl_cc_library(
  NAME
    algorithm
  HDRS
    "algorithm.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
  PUBLIC
)

absl_cc_test(
  NAME
    algorithm_test
  SRCS
    "algorithm_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::algorithm
    absl::config
    GTest::gmock_main
)

absl_cc_library(
  NAME
    algorithm_container
  HDRS
    "container.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::algorithm
    absl::core_headers
    absl::meta
  PUBLIC
)

absl_cc_test(
  NAME
    container_test
  SRCS
    "container_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::algorithm_container
    absl::base
    absl::core_headers
    absl::memory
    absl::span
    GTest::gmock_main
)

=== tools/vendor/abseil-cpp/absl/hash/CMakeLists.txt ===
#
# Copyright 2018 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

absl_cc_library(
  NAME
    hash
  HDRS
    "hash.h"
  SRCS
    "internal/hash.cc"
    "internal/hash.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::bits
    absl::city
    absl::config
    absl::core_headers
    absl::endian
    absl::fixed_array
    absl::function_ref
    absl::meta
    absl::int128
    absl::strings
    absl::optional
    absl::variant
    absl::utility
    absl::low_level_hash
  PUBLIC
)

absl_cc_library(
  NAME
    hash_testing
  HDRS
    "hash_testing.h"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::spy_hash_state
    absl::meta
    absl::strings
    absl::variant
    GTest::gmock
  TESTONLY
  PUBLIC
)

absl_cc_test(
  NAME
    hash_test
  SRCS
    "hash_test.cc"
    "internal/hash_test.h"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::cord_test_helpers
    absl::hash
    absl::hash_testing
    absl::core_headers
    absl::btree
    absl::flat_hash_map
    absl::flat_hash_set
    absl::node_hash_map
    absl::node_hash_set
    absl::spy_hash_state
    absl::meta
    absl::int128
    GTest::gmock_main
)

absl_cc_test(
  NAME
    hash_instantiated_test
  SRCS
    "hash_test.cc"
    "internal/hash_test.h"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::hash
    absl::hash_testing
    absl::config
    absl::btree
    absl::flat_hash_map
    absl::flat_hash_set
    absl::node_hash_map
    absl::node_hash_set
    GTest::gtest_main
)

# Internal-only target, do not depend on directly.
#
# Note: Even though external code should not depend on this target
# directly, it must be marked PUBLIC since it is a dependency of
# hash_testing.
absl_cc_library(
  NAME
    spy_hash_state
  HDRS
    "internal/spy_hash_state.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::hash
    absl::strings
    absl::str_format
  TESTONLY
  PUBLIC
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    city
  HDRS
    "internal/city.h"
  SRCS
    "internal/city.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
    absl::core_headers
    absl::endian
)

absl_cc_test(
  NAME
    city_test
  SRCS
    "internal/city_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::city
    GTest::gmock_main
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    low_level_hash
  HDRS
    "internal/low_level_hash.h"
  SRCS
    "internal/low_level_hash.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
    absl::endian
    absl::int128
    absl::prefetch
)

absl_cc_test(
  NAME
    low_level_hash_test
  SRCS
    "internal/low_level_hash_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::low_level_hash
    absl::strings
    GTest::gmock_main
)

=== tools/vendor/abseil-cpp/absl/synchronization/CMakeLists.txt ===
#
# Copyright 2017 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    graphcycles_internal
  HDRS
    "internal/graphcycles.h"
  SRCS
    "internal/graphcycles.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::base
    absl::base_internal
    absl::config
    absl::core_headers
    absl::malloc_internal
    absl::raw_logging_internal
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    kernel_timeout_internal
  HDRS
    "internal/kernel_timeout.h"
  SRCS
    "internal/kernel_timeout.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::base
    absl::config
    absl::core_headers
    absl::raw_logging_internal
    absl::time
)

absl_cc_test(
  NAME
    kernel_timeout_internal_test
  SRCS
    "internal/kernel_timeout_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::kernel_timeout_internal
    absl::config
    absl::random_random
    absl::time
    GTest::gmock_main
)

absl_cc_library(
  NAME
    synchronization
  HDRS
    "barrier.h"
    "blocking_counter.h"
    "internal/create_thread_identity.h"
    "internal/futex.h"
    "internal/futex_waiter.h"
    "internal/per_thread_sem.h"
    "internal/pthread_waiter.h"
    "internal/sem_waiter.h"
    "internal/stdcpp_waiter.h"
    "internal/waiter.h"
    "internal/waiter_base.h"
    "internal/win32_waiter.h"
    "mutex.h"
    "notification.h"
  SRCS
    "barrier.cc"
    "blocking_counter.cc"
    "internal/create_thread_identity.cc"
    "internal/futex_waiter.cc"
    "internal/per_thread_sem.cc"
    "internal/pthread_waiter.cc"
    "internal/sem_waiter.cc"
    "internal/stdcpp_waiter.cc"
    "internal/waiter_base.cc"
    "internal/win32_waiter.cc"
    "notification.cc"
    "mutex.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::graphcycles_internal
    absl::kernel_timeout_internal
    absl::atomic_hook
    absl::base
    absl::base_internal
    absl::config
    absl::core_headers
    absl::dynamic_annotations
    absl::malloc_internal
    absl::raw_logging_internal
    absl::stacktrace
    absl::symbolize
    absl::time
    Threads::Threads
  PUBLIC
)

absl_cc_test(
  NAME
    barrier_test
  SRCS
    "barrier_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::synchronization
    absl::time
    GTest::gmock_main
)

absl_cc_test(
  NAME
    blocking_counter_test
  SRCS
    "blocking_counter_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::synchronization
    absl::time
    GTest::gmock_main
)

absl_cc_test(
  NAME
    graphcycles_test
  SRCS
    "internal/graphcycles_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::check
    absl::core_headers
    absl::graphcycles_internal
    absl::log
    GTest::gmock_main
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    thread_pool
  HDRS
    "internal/thread_pool.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::any_invocable
    absl::core_headers
    absl::synchronization
  TESTONLY
)

absl_cc_test(
  NAME
    mutex_test
  SRCS
    "mutex_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::synchronization
    absl::thread_pool
    absl::base
    absl::check
    absl::config
    absl::core_headers
    absl::log
    absl::memory
    absl::time
    GTest::gmock_main
)

absl_cc_test(
  NAME
    mutex_method_pointer_test
  SRCS
    "mutex_method_pointer_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::base
    absl::config
    absl::synchronization
    GTest::gmock_main
)

absl_cc_test(
  NAME
    notification_test
  SRCS
    "notification_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::synchronization
    absl::time
    GTest::gmock_main
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    per_thread_sem_test_common
  SRCS
    "internal/per_thread_sem_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::synchronization
    absl::base
    absl::config
    absl::strings
    absl::time
    GTest::gmock
  TESTONLY
)

absl_cc_test(
  NAME
    per_thread_sem_test
  SRCS
    "internal/per_thread_sem_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::per_thread_sem_test_common
    absl::synchronization
    absl::strings
    absl::time
    GTest::gmock_main
)

absl_cc_test(
  NAME
    waiter_test
  SRCS
    "internal/waiter_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::config
    absl::kernel_timeout_internal
    absl::random_random
    absl::synchronization
    absl::thread_pool
    absl::time
    GTest::gmock_main
)

absl_cc_test(
  NAME
    lifetime_test
  SRCS
    "lifetime_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::synchronization
    absl::core_headers
    absl::check
)

=== tools/vendor/abseil-cpp/absl/types/CMakeLists.txt ===
#
# Copyright 2017 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
absl_cc_library(
  NAME
    any
  HDRS
    "any.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::bad_any_cast
    absl::config
    absl::core_headers
    absl::fast_type_id
    absl::type_traits
    absl::utility
  PUBLIC
)

absl_cc_library(
  NAME
    bad_any_cast
  HDRS
   "bad_any_cast.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::bad_any_cast_impl
    absl::config
  PUBLIC
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    bad_any_cast_impl
  SRCS
   "bad_any_cast.h"
   "bad_any_cast.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
    absl::raw_logging_internal
)

absl_cc_test(
  NAME
    any_test
  SRCS
    "any_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::any
    absl::config
    absl::exception_testing
    absl::log
    absl::test_instance_tracker
    GTest::gmock_main
)

absl_cc_test(
  NAME
    any_test_noexceptions
  SRCS
    "any_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::any
    absl::config
    absl::exception_testing
    absl::raw_logging_internal
    absl::test_instance_tracker
    GTest::gmock_main
)

absl_cc_test(
  NAME
    any_exception_safety_test
  SRCS
    "any_exception_safety_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::any
    absl::config
    absl::exception_safety_testing
    GTest::gmock_main
)

absl_cc_library(
  NAME
    span
  HDRS
    "span.h"
  SRCS
    "internal/span.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::algorithm
    absl::core_headers
    absl::throw_delegate
    absl::type_traits
  PUBLIC
)

absl_cc_test(
  NAME
    span_test
  SRCS
    "span_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::span
    absl::base
    absl::config
    absl::core_headers
    absl::exception_testing
    absl::fixed_array
    absl::inlined_vector
    absl::hash_testing
    absl::strings
    GTest::gmock_main
)

absl_cc_test(
  NAME
    span_test_noexceptions
  SRCS
    "span_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::span
    absl::base
    absl::config
    absl::core_headers
    absl::exception_testing
    absl::fixed_array
    absl::inlined_vector
    absl::hash_testing
    absl::strings
    GTest::gmock_main
)

absl_cc_library(
  NAME
    optional
  HDRS
    "optional.h"
  SRCS
    "internal/optional.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::bad_optional_access
    absl::base_internal
    absl::config
    absl::core_headers
    absl::memory
    absl::type_traits
    absl::utility
  PUBLIC
)

absl_cc_library(
  NAME
    bad_optional_access
  HDRS
    "bad_optional_access.h"
  SRCS
    "bad_optional_access.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
    absl::raw_logging_internal
  PUBLIC
)

absl_cc_library(
  NAME
    bad_variant_access
  HDRS
    "bad_variant_access.h"
  SRCS
    "bad_variant_access.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
    absl::raw_logging_internal
  PUBLIC
)

absl_cc_test(
  NAME
    optional_test
  SRCS
    "optional_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::optional
    absl::config
    absl::log
    absl::strings
    absl::type_traits
    GTest::gmock_main
)

absl_cc_test(
  NAME
    optional_exception_safety_test
  SRCS
    "optional_exception_safety_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::optional
    absl::config
    absl::exception_safety_testing
    GTest::gmock_main
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    conformance_testing
  HDRS
    "internal/conformance_aliases.h"
    "internal/conformance_archetype.h"
    "internal/conformance_profile.h"
    "internal/conformance_testing.h"
    "internal/conformance_testing_helpers.h"
    "internal/parentheses.h"
    "internal/transform_args.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::algorithm
    absl::debugging
    absl::type_traits
    absl::strings
    absl::utility
    GTest::gmock_main
  TESTONLY
)

absl_cc_test(
  NAME
    conformance_testing_test
  SRCS
    "internal/conformance_testing_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
    ${ABSL_EXCEPTIONS_FLAG}
  LINKOPTS
    ${ABSL_EXCEPTIONS_FLAG_LINKOPTS}
  DEPS
    absl::conformance_testing
    absl::type_traits
    GTest::gmock_main
)

absl_cc_test(
  NAME
    conformance_testing_test_no_exceptions
  SRCS
    "internal/conformance_testing_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::conformance_testing
    absl::type_traits
    GTest::gmock_main
)

absl_cc_library(
  NAME
    variant
  HDRS
    "variant.h"
  SRCS
    "internal/variant.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::bad_variant_access
    absl::base_internal
    absl::config
    absl::core_headers
    absl::type_traits
    absl::utility
  PUBLIC
)

absl_cc_test(
  NAME
    variant_test
  SRCS
    "variant_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::variant
    absl::config
    absl::core_headers
    absl::memory
    absl::type_traits
    absl::strings
    GTest::gmock_main
)

absl_cc_library(
  NAME
    compare
  HDRS
    "compare.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::core_headers
    absl::type_traits
  PUBLIC
)

absl_cc_test(
  NAME
    compare_test
  SRCS
    "compare_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::base
    absl::compare
    GTest::gmock_main
)

absl_cc_test(
  NAME
    variant_exception_safety_test
  SRCS
    "variant_exception_safety_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::variant
    absl::config
    absl::exception_safety_testing
    absl::memory
    GTest::gmock_main
)

=== debian/changelog ===
r-cran-s2 (1.1.9-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 1.1.9. re-diff patches.
  * Drop Redundant "Rules-Requires-Root: no"
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Drop myself from uploaders

 -- Nilesh Patra <nilesh@debian.org>  Sun, 26 Oct 2025 19:50:44 +0530

=== debian/control ===
--- 
+++ 
@@ -2,18 +2,18 @@
 Section: gnu-r
 Priority: optional
 Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
-Uploaders: Andreas Tille <tille@debian.org>, Nilesh Patra <nilesh@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-s2
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-s2.git
 Homepage: https://cran.r-project.org/package=s2
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13),
                dh-r,
                r-base-dev,
                r-cran-rcpp,
                r-cran-wk (>= 0.6.0),
-               libssl-dev
+               libssl-dev,
+               libabsl-dev
 Testsuite: autopkgtest-pkg-r
 
 Package: r-cran-s2

=== debian/tests/control ===
Tests: run-unit-test
Depends: @,
         r-cran-bit64,
        r-cran-testthat (>= 3.0.0),
        r-cran-vctrs
Restrictions: allow-stderr, skippable

=== debian/watch ===
version=4
https://cloud.r-project.org/src/contrib/s2_([-\d.]*)\.tar\.gz
